###########################################################
#
#
#  To analyze an particular alignment scheme, the following is needed:
#
#  Assumes all particpating coils have been generated with the runall.s * doall.s scripts
#   to calculate as-built coils (ie .A1) and bmns from displacements of as-built coils (ie A1_dx, A1_dy, ...)
#
# see do1.s script
#  Generate the combined del coilset for all participating coils
#
#  Run vacisld with combined del coilset to generate target bmns
#
#  Create svd.inp with target and existing bmns from displacements of as-built coils (ie A1_dx, A1_dy, ...)
#
#  Run svd.x (see below)
#
#  use extcur results (displacements) to create realigned coil set
#
#
# Repeat again for All coils targeting all modes collectively
#
#set ID = ABC16
#set coillist = "A1 A2 A3 A4 A5 A6x B1 B2 B3 B4 B5 B6x C1 C2 C3 C4 C5 C6"
#set ID = A16
#set coillist = "A1 A2 A3 A4 A5 A6x"
#set ID = B16
#set coillist = "B1 B2 B3 B4 B5 B6x"
set ID = C16
set coillist = "C1 C2 C3 C4 C5 C6"
echo $ID $coillist
#
../svd.x < svd.inp."$ID" >! svd.out."$ID"
/bin/mv extcur extcur."$ID"
#
/bin/rm coils."$ID"_tr4
touch coils."$ID"_tr4  # realigned coils - design
#
/bin/rm coils."$ID"tr4
touch coils."$ID"tr4  # realigned coils only
#
@ i = 0
foreach coil ($coillist)
echo coil = $coil
@ i += 1
# create csystrans.inp files to transform local csys to global csys
#
/bin/cp csystrans.inp."$coil" csystrans.inp."$coil"r4
tedi csystrans.inp."$coil"r4 << EOF
dl2;cfa $i,$i,.;extcur.$ID;end
EOF
#
#
../csystrans.x < csystrans.inp."$coil"r4 >! csystrans.out."$coil"r4
#
#  apply coordinate transform to coils
#
../transcoils.x "$coil" 4 < csystrans.out."$coil"r4
#
cat coils."$coil"_tr4 >> coils."$ID"_tr4
cat coils."$coil"tr4 >> coils."$ID"tr4
#
end
#
###########################################################
# realigned coils - design (ie delta coil set for VACISLD)
tedi coils."$ID"_tr4 << EOF
dos1,]-10;end;dl.,.+4;ndo;end
EOF
#
###########################################################
# realgined coils only
tedi coils."$ID"tr4 << EOF
dos1,]-10;end;dl.,.+4;ndo;end
EOF
#
###########################################################
#
# Check final coil set with Vacisld
#
xvacisld9 m50_e04x coils."$ID"_tr4 noread
#
###########################################################
