#
###########################################################
# NOTE: NEED TO SCALE GEOMETRY TO LN2 TEMP PRIOR TO RUNNING VACISLD
#       BUT AFTER DOING ROTATIONS!!!
#
# Create as built coils files from dxc, dyc data for each coil
# Inputs: "$1"_CurCen.txt
# Plus:
set coilname = $1  #  A1
set theta    = $2  # -10.
set rad      = $3  # 1.5
set ig       = $4  #  1
set type     = $5  #  A
set iper     = $6  #  1
set isym     = $7  #  -1
set cur      = $8  #  6.52271941985300E+05
#
set del      = 0.001  #  normally leave set at 0.001
set CurCen = "$coilname"_CurCen.txt
#
/bin/cp ../coilcurcen.inp."$type"  coilcurcen.inp."$coilname"
tedi coilcurcen.inp."$coilname" << EOF
cfa3,*,];$CurCen
al]; $ig $type $cur $iper $isym;.
end
EOF
#
../coilcurcen3.x < coilcurcen.inp."$coilname"
/bin/mv coils.delta coils."$coilname"del
/bin/mv coils.deform coils."$coilname"
/bin/mv coils.undeformed coils."$coilname"des
../d.x < coils."$coilname"del
../r.x < "$coilname"_CurCen.txt
##
#
###########################################################
#
# generate unit displacement coil sets for each
#
../displcoils.x  $coilname $rad $theta $del
##
###########################################################
#
# Compute svd Targets (bmns of asbuilt coils sets)
#   and Coupling Matrix (bmns for each coil displacement)
#
# (from vacisld.s script)
#
xvacisld9 m50_e04x coils."$coilname"del noread
#
xvacisld9 m50_e04x coils."$coilname"_dx noread
xvacisld9 m50_e04x coils."$coilname"_dy noread
xvacisld9 m50_e04x coils."$coilname"_dz noread
xvacisld9 m50_e04x coils."$coilname"_rx noread
xvacisld9 m50_e04x coils."$coilname"_ry noread
xvacisld9 m50_e04x coils."$coilname"_rz noread
#
#  ###########################################################
# Remove blank lines from bmns file
tedi bmns << EOF
dnp*;.;dl;ndo;end
EOF
#TMP###########################################################
#TMP#
#TMP# Solve SVD Problem after creating inputs from bmns Targets and Coupling Matrix
#TMP#  using bmns file from vacisld
#TMP#
#TMPcat << EOF >! svd.inp."$coilname"
#TMP  6, 6, 1.e-6 / ntargets, ncoils, cutoff
#TMP 1 1 0 0 1 1
#TMP                    Bm5n3sin       Bm5n3cos      Bm6n3sin       Bm6n3cos      Bm2n1sin       Bm2n1cos
#TMPEOF
#TMP#
#TMPtail -7 bmns >> svd.inp."$coilname"
#TMP#
#TMP../svd.x < svd.inp."$coilname" >! svd.out."$coilname"
#TMP/bin/mv extcur extcur."$coilname"
#TMP#
#TMP###########################################################
#TMP#
#TMP# Use Calculated displacements from SVD output to form Coil transformation Matrix
#TMP
#TMP# First Build input file
#TMPcat >! csystrans.inp."$coilname" << EOF
#TMP $rad $theta $del $iper $isym
#TMPEOF
#TMPcat extcur."$coilname" >> csystrans.inp."$coilname"
#TMPcat >> csystrans.inp."$coilname" << EOF
#TMP 1
#TMP 0. 0. 0.
#TMPEOF
#TMP#
#TMP../csystrans.x < csystrans.inp."$coilname" >! csystrans.out."$coilname"
#TMP#
#TMP# The following can be run if conical seat data is avaiable and added to csystrans.inp
#TMP#  ../csystrans3.x < csystrans.inp."$coilname" >! csystrans3.out."$coilname"
#TMP#
#TMP###########################################################
#TMP#
#TMP# Apply Coil transformation Matrix to Coils
#TMP#
#TMP../transcoils.x "$coilname"  1 < csystrans.out."$coilname"
#TMP#
#TMP###########################################################
#TMP#
#TMP# Check final coil set with Vacisld
#TMP#
#TMPxvacisld9 m50_e04x coils."$coilname"_tr1 noread
#TMP#
#TMP###########################################################
#TMP#
#TMP# Convert final transformations for each coil to ProE format
#TMP#
#TMP../proe_csys/invtrans.x < csystrans.out."$coilname" >! ProE_Csys."$coilname"
#TMP#
