c***********************************************************
      module svddata
      implicit real*8(a-h,o-z)
      real*8, dimension(:,:), allocatable :: bmns_coils
      real*8, dimension(:), allocatable :: bmns_target, bmns_resid, bmns
      real*8, dimension(:), allocatable :: curs,x_upper,x_lower
      real*8 :: curmax, bmns1
      integer :: mmode, mcoil
      character*32 lab
      character*16, dimension(:), allocatable ::  lab_target, lab_coil
      integer, dimension(:), allocatable :: m
      real*8, dimension(:), allocatable :: xiotap
      end module svddata
c***********************************************************
      use svddata
      use nag_nlp
      implicit real*8(a-h,o-z)
      type(nag_nlp_cntrl_dp) :: cntrl
      character*16 labx
      external obj_fun, con_fun
c
      call nag_nlp_cntrl_init(cntrl)
      cntrl.list=.false.
      cntrl.unit=15
      open(unit=9,file="nlp.inp",status="old")
      read(9,*) mmode,mcoil , curmax
c
      allocate(bmns_coils(mmode,mcoil)) ! A matrix
      allocate(lab_target(mmode))
      allocate(lab_coil(mcoil))
      allocate(curs(mcoil), bmns_target(mmode), bmns_resid(mmode))
      allocate(bmns(mmode))
c
      read(9,*) (lab_target(i),i=1,mmode)
c
      do j=1,mcoil
      read(9,*) lab_coil(j), (bmns_coils(i,j),i=1,mmode)
      enddo
      close(9)
c
      allocate(m(mmode))
      allocate(xiotap(mmode))
      allocate(x_upper(mcoil),x_lower(mcoil))
c
      open(unit=7,file="trim_svd2.inp",status="old")
      read(7,*) labx, bmns_target
      read(7,*) m(1:mmode)
      read(7,*) xiotap(1:mmode)
c
      bmns_target=-bmns_target
c
      x_lower(1:mcoil)=-curmax
      x_upper(1:mcoil)=+curmax
      call nag_nlp_sol(obj_fun,curs,obj_f,obj_deriv=.false.,
     +   con_deriv=.false., num_nlin_con=0, con_fun=con_fun,
     + control=cntrl,
     +   x_lower=x_lower, x_upper=x_upper)
c
      write(*,*) "Max Current = ", abs(maxval(curs))
      write(*,*) "curs"
      write(*,"(1p6e15.6)") curs
      write(*,"(6a15)") lab_target
      write(*,*) "bmns_resid"
      write(*,"(1p6e15.6)") bmns_resid
c
      do j=1,mmode,2
       bmns(j) = sqrt( bmns_resid(j)**2 + bmns_resid(j+1)**2)
        bmns(j) = 4.d0*sqrt(abs(bmns(j))/m(j)/xiotap(j))
      enddo
      call sum_island2(bmns, xiotap, m, bmns1)
c
      write(*,*) "Island Size, %Total Flux"
      write(*,"(6a15)") lab_target(1:mmode:2)
      write(*,"(6f15.2)") bmns(1:mmode:2)*100.d0, bmns1*100.d0
      stop
      end
c***********************************************************
      subroutine obj_fun(first_call, x, finish, obj_f) ! , obj_grad)
      use svddata
      implicit real*8(a-h,o-z)
c
      logical, intent(in) :: first_call
      real*8, intent(in) :: x(:)
      logical, intent(out) :: finish
      real*8, intent(out) :: obj_f
!      real*8, intent(inout), optional :: obj_grad(:)
c
      bmns_resid=matmul(bmns_coils,x)-bmns_target
      obj_f=dot_product(bmns_resid,bmns_resid)*1.d12
c
!      do j=1,mmode,2
!       bmns(j) = sqrt( bmns_resid(j)**2 + bmns_resid(j+1)**2)
!        bmns(j) = 4.d0*sqrt(abs(bmns(j))/m(j)/xiotap(j))
!      enddo
!      call sum_island2(bmns, xiotap, m, bmns1)
!      obj_f=bmns1*100.d0 ! sum of islands %
c
      return
      end
      subroutine con_fun
      return
      end
c***********************************************************
      subroutine sum_island2(bmns, xiotap, m, bmns1)
      implicit none
      integer, parameter :: nmns = 20
      real*8, dimension(nmns) :: bmns
      real*8, dimension(nmns) :: xiotap
      integer, dimension(nmns) :: m
      real*8 ::  ds, bmns1
      integer :: mi, nm
c
c this routine sums islands assuming the following resonances are present
c IT DOES NOT WORK FOR ANY OTHER  LIST OF RESONANCES
c                  m5n3s   m5n3c  m10n6s  m10n6c   m6n3s   m6n3c
c                 m12n6s  m12n6c   m7n3s   m7n3c  m14n6s  m14n6c
c                  m2n1s   m2n1c   m4n2s   m4n2c   m3n2s   m3n2c
c                  m6n4s   m6n4c
c
c 4 surfaces in total, 2 resonances each except 1/2 whcih combines with 3/6
c
      real*8, dimension(4) :: bms, bmc
c
      bmns1 = 0.d0 ! initialize sum
c
c 3/5 surface
c
      ds=max(bmns(1),bmns(3))
      bmns1 = bmns1 + ds
c
c 1/2 surface & 3/6
c
      ds=max(bmns(13),bmns(15),bmns(5),bmns(7))
      bmns1 = bmns1 + ds
c
c 3/7 surface
c
      ds=max(bmns(9),bmns(11))
      bmns1 = bmns1 + ds
c
c 2/3 surface
c
      ds=max(bmns(17),bmns(19))
      bmns1 = bmns1 + ds
c
      return
      end
c***********************************************************
